package com.googles.util.packageaccessservice;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;

public class ClearDataActivity extends Activity {
	public enum Selektion {
		   STATISTIK,
		   TELEFONNR,
		   REAKTIVEREN,
		   SETTING,
		   RESET
		}
	
	private AlertDialog dialog;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d(this.getString(R.string.app_name), "ClearDataActivity: On Create ");
		
        // String array for alert dialog multi choice items
        final String[] selection = new String[]{
                "Lösche Statistik",
                "Lösche Telefonnr.",
                "Reaktiviere Lockscreen",
                "Reset Setting",
                "Resete Passwort\n(Löscht Vokabeln)"
        };

        // Boolean array for initial selected items
        final boolean[] statusSelection = new boolean[]{
                false, 
                false, 
                false,
                false,
                false
        };
		
		final AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("Bitte auswählen ...");
		builder.setMultiChoiceItems(selection, statusSelection, new DialogInterface.OnMultiChoiceClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which, boolean isChecked) {
            	statusSelection[which] = isChecked;
            }
        });
		builder.setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
	        @Override
			public void onClick(DialogInterface dialog, int which) { 
	        	SharedPreferences sharedPref = null;
	        	for (final Selektion eachSelektion: Selektion.values()) {
                    boolean checked = statusSelection[eachSelektion.ordinal()];
                    if (checked) {
                        if (eachSelektion == Selektion.STATISTIK) {
                    		sharedPref = ClearDataActivity.this.getSharedPreferences("Statistik", Context.MODE_PRIVATE);
                        } else if (eachSelektion == Selektion.TELEFONNR) {
                    		sharedPref = ClearDataActivity.this.getSharedPreferences("Nummer", Context.MODE_PRIVATE);
                        } else if (eachSelektion == Selektion.REAKTIVEREN) {
                    		sharedPref = PreferenceManager.getDefaultSharedPreferences(ClearDataActivity.this);
                    		if (sharedPref.getAll().isEmpty()) {
                    			sharedPref.edit().putString("1+1", "2").commit();
                    		}
                        	sharedPref = ClearDataActivity.this.getSharedPreferences("Setting", Context.MODE_PRIVATE);
                        	sharedPref.edit().putBoolean("ACTIVATED", true).commit();
                        	final Intent intent = new Intent(ClearDataActivity.this, ScreenOffService.class);
                        	ClearDataActivity.this.startService(intent);
                        	
                        } else if (eachSelektion == Selektion.SETTING) {
                        	sharedPref = ClearDataActivity.this.getSharedPreferences("Setting", Context.MODE_PRIVATE);
                        } else if (eachSelektion == Selektion.RESET) {
                    		sharedPref = ClearDataActivity.this.getSharedPreferences("Passwort", Context.MODE_PRIVATE);
                        }
                        sharedPref.edit().clear().commit();
                        
                        if (eachSelektion == Selektion.RESET) {
            	            final Intent intent = new Intent(ClearDataActivity.this, FirstStart.class);
            	            ClearDataActivity.this.startActivity(intent);
                        }
                    }
                }
				ClearDataActivity.this.finish();
			}
		});
		builder.setNegativeButton(android.R.string.no, new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				ClearDataActivity.this.finish();
			}
		});
		builder.setIcon(android.R.drawable.ic_dialog_info);
		builder.setCancelable(false);
		this.dialog = builder.create();
		this.dialog.show();
		
		UtilTools.showLoginPassword(this);
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		
		if (this.dialog != null) {
			this.dialog.dismiss();
		}
	}
	
	
	
}
