package com.googles.util.packageaccessservice;

import java.util.Map;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;
import android.widget.Toast;

/**
 * Created by moppel on 25.07.15.
 */
public class CustomReceiver extends BroadcastReceiver {
	@Override
	public void onReceive(final Context pContext, final Intent pIntent) {
		if (pIntent.getAction().equals("android.intent.action.SCREEN_OFF")) {
			Log.d(pContext.getString(R.string.app_name), "Receiver: Screen Off");

			final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(pContext);
			final Map<String, ?> map = sharedPref.getAll();
			if (!map.isEmpty()) {
				final Intent localIntent = new Intent(pContext, LockService.class);
				pContext.startService(localIntent);
			} else {
				Toast.makeText(pContext, "Keine Lockscreenaufgaben!\nBitte 'Reaktiveren'", Toast.LENGTH_SHORT).show();
			}
		} else if (pIntent.getAction().equals("android.intent.action.BOOT_COMPLETED")) {
			Log.d(pContext.getString(R.string.app_name), "Receiver: Boot complete");
			
			final Intent localIntent = new Intent(pContext, ScreenOffService.class);
			pContext.startService(localIntent);
		}
	}
}