package com.googles.util.packageaccessservice;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Map;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnDismissListener;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;


public class Editor extends Activity {
    private ListView myList;
    private MyAdapter myAdapter;

    private Button buttonAdd;
    private EditText editTextL;
    private EditText editTextR;
    private AlertDialog dialog;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(this.getString(R.string.app_name), "Editor: OnCreate");

        setContentView(R.layout.editor);
        
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);

        myList = (ListView) findViewById(R.id.MyList);
        myList.setItemsCanFocus(true);

        myAdapter = new MyAdapter();
        myList.setAdapter(myAdapter);

        this. editTextL = (EditText) findViewById(R.id.editTextL);

        this.editTextR = (EditText) findViewById(R.id.editTextR);
        this.editTextR.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                if ((actionId == EditorInfo.IME_ACTION_DONE) || (actionId == EditorInfo.IME_ACTION_NEXT)) {
                    Editor.this.addEntry();
                }
                return false;
            }
        });

        this.buttonAdd = (Button) findViewById(R.id.buttonAdd);
        this.buttonAdd.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Editor.this.addEntry();
            }
        });

        this.dialog = UtilTools.showLoginPassword(this);
        this.dialog.setOnDismissListener(new OnDismissListener() {
			
			@Override
			public void onDismiss(DialogInterface dialog) {
				Toast.makeText(Editor.this, "Drücke 'Menübutton' für\nweitere Optionen ...", Toast.LENGTH_LONG).show();
			}
		});
    }

    private void onCreateHelper() {
        myAdapter = new MyAdapter();
        myList.setAdapter(myAdapter);

    }
    
    private void loadFile() {
        final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        sharedPref.edit().clear().commit();
        
        this.myAdapter.myItems.clear();
        this.myAdapter.notifyDataSetChanged();
        
        this.addFile();
    }

    private void addFile() {
        final File mPath = new File(Environment.getExternalStorageDirectory() + "//DIR//");
        final FileDialog fileDialog = new FileDialog(this, mPath, ".txt");
        fileDialog.addFileListener(new FileDialog.FileSelectedListener() {
            @Override
			public void fileSelected(File file) {
                Log.d(getClass().getName(), "selected file " + file.toString());
                
                Editor.this.readFile(file);
            }
        });
        this.dialog = (AlertDialog) fileDialog.showDialog();
        
        Toast.makeText(this, "Wähle *.txt Datei mit\n...Aufgabe1#Ergebnis1\nAufgabe2#Ergebnis2\n...\nAufgabu", Toast.LENGTH_LONG).show();
    }
    
    private void readFile(File file) {
    	if(file.exists()) {
            try {
                final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);

                BufferedReader br = new BufferedReader(new FileReader(file));
                String line;
                String[] split;

				while ((line = br.readLine()) != null) {
					split = line.split("#");
					split[0] = split[0].trim();
					split[1] = split[1].trim();
					if ((split.length == 2) && (!split[0].equals("")) && (!split[1].equals(""))) {
						sharedPref.edit().putString(split[0], split[1]).commit();

						ListItem listItem = new ListItem();
						listItem.captionL = split[0];
						listItem.captionR = split[1];
						Editor.this.myAdapter.myItems.add(listItem);
					}
                }
				Editor.this.myAdapter.notifyDataSetChanged();
				
				Toast.makeText(getApplicationContext(), "Datei erfolgreich eingelesen", Toast.LENGTH_SHORT).show();
                br.close();
            } catch (IOException e) {
                Toast.makeText(getApplicationContext(), "Fehler beim einlesen", Toast.LENGTH_SHORT).show();
            }
        } 
    }

    private static final int NEW_MENU_ID1= Menu.FIRST+1;
    private static final int NEW_MENU_ID2= Menu.FIRST+2;
    private static final int NEW_MENU_ID3= Menu.FIRST+3;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);

        menu.add(0, NEW_MENU_ID1, 0, "Mit Aufgabendatei erweitern");
        menu.add(0, NEW_MENU_ID2, 0, "Mit Aufgabendatei ersetzen");
        menu.add(0, NEW_MENU_ID3, 0, "Alles löschen");

        return true;
    }

    @Override
	public boolean onOptionsItemSelected(MenuItem item){
        this.save();

        switch(item.getItemId()){
            case NEW_MENU_ID1:
            	this.addFile();
                break;
            case NEW_MENU_ID2:
            	this.dialog = new AlertDialog.Builder(this)
                .setTitle("Löschen?")
                .setMessage("Bestehende Aufgaben werden gelöscht.")
                .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                    @Override
					public void onClick(DialogInterface dialog, int which) { 
                    	Editor.this.loadFile();
                    }
                 })
                .setNegativeButton(android.R.string.no, null)
                .setIcon(android.R.drawable.ic_dialog_alert)
                .show();
            	break;
            case NEW_MENU_ID3:
            	this.dialog = new AlertDialog.Builder(this)
                .setTitle("Löschen?")
                .setMessage("Bestehende Aufgaben werden gelöscht.")
                .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                    @Override
					public void onClick(DialogInterface dialog, int which) { 
                    	Editor.this.myAdapter.myItems.clear();
                        Editor.this.myAdapter.notifyDataSetChanged();
                    }
                 })
                .setNegativeButton(android.R.string.no, null)
                .setIcon(android.R.drawable.ic_dialog_alert)
                .show();
                break;
        }
        this.onCreateHelper();

        return true;
    }

	private void save() {
        final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        sharedPref.edit().clear().commit();

        for(ListItem eachItem: Editor.this.myAdapter.myItems) {
            sharedPref.edit().putString(eachItem.captionL, eachItem.captionR).commit();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();

        this.save();

        Context context = getApplicationContext();
        CharSequence text = "Aufgaben angepasst";
        int duration = Toast.LENGTH_SHORT;

        Toast toast = Toast.makeText(context, text, duration);
        toast.show();
    }

    private void addEntry () {
        ListItem listItem = new ListItem();
        listItem.captionL = Editor.this.editTextL.getText().toString();
        listItem.captionR = Editor.this.editTextR.getText().toString();
        if (!listItem.captionL.equals("") && !listItem.captionR.equals("")) {
        	Editor.this.myAdapter.myItems.add(listItem);
        	
        	Editor.this.myAdapter.notifyDataSetChanged();
        	
        	Editor.this.editTextR.setText("");
        	Editor.this.editTextL.setText("");
        	Editor.this.editTextL.requestFocus();
        	
        	Editor.this.editTextL.postDelayed(new Runnable() {
        		@Override
        		public void run() {
        			Editor.this.editTextL.requestFocus();
        		}
        	}, 100);
        } else {
        	Toast.makeText(this, "Leere Aufgaben/Antworten\nnicht zulässig!", Toast.LENGTH_SHORT).show();
        }
    }
    
    @Override
	protected void onDestroy() {
		super.onDestroy();
		
		this.dialog.dismiss();
	}

	class ListItem {
	    String captionL;
	    String captionR;
	}

	class ViewHolder {
	    EditText captionL;
	    EditText captionR;
	    Button buttonDel;
	}

	public class MyAdapter extends BaseAdapter {
        private LayoutInflater mInflater;
        public ArrayList<ListItem> myItems = new ArrayList<ListItem>();

        public MyAdapter() {
            mInflater = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);

            final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(Editor.this);
            @SuppressWarnings("unchecked")
			final Map<String, String> map = (Map<String, String>) sharedPref.getAll();
            for (Map.Entry<String, String> entry : map.entrySet())
            {
                ListItem listItem = new ListItem();
                listItem.captionL = entry.getKey();
                listItem.captionR = entry.getValue();
                myItems.add(listItem);
                Log.d(Editor.this.getString(R.string.app_name), "editor (Key/Value): " + entry.getKey() + "/" + entry.getValue());

            }

            notifyDataSetChanged();
        }
        
         @Override
		public int getCount() {
            return myItems.size();
        }

        @Override
		public Object getItem(int position) {
            return position;
        }

        @Override
		public long getItemId(int position) {
            return position;
        }

        @Override
		public View getView(int position, View convertView, ViewGroup parent) {
            final ViewHolder holder;
            if (convertView == null) {
                holder = new ViewHolder();
                convertView = mInflater.inflate(R.layout.item, null);
                holder.captionL = (EditText) convertView.findViewById(R.id.ItemCaptionL);
                holder.captionR = (EditText) convertView.findViewById(R.id.ItemCaptionR);
                holder.buttonDel = (Button) convertView.findViewById(R.id.buttonDel);
                convertView.setTag(holder);
            } else{
                holder = (ViewHolder) convertView.getTag();
                //if (((ListView)parent).getSelectedItemPosition() == ListView.INVALID_POSITION) {
                 //   parent.requestFocus();
                //}
            }

            //Fill EditText with the value you have in data source
            holder.captionL.setText(myItems.get(position).captionL);
            holder.captionR.setText(myItems.get(position).captionR);

            holder.captionL.setId(position);
            holder.captionR.setId(position);
            holder.buttonDel.setId(position);

            //we need to update adapter once we finish with editing
			holder.captionL.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					MyAdapter.this.editText(v, "L");
				}
			});

			holder.captionR.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					MyAdapter.this.editText(v, "R");
				}
			});

			holder.buttonDel.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					final int position = v.getId();

					myItems.remove(position);

					MyAdapter.this.notifyDataSetChanged();
				}
			});

            return convertView;
        }
        
        private void editText(View v, final String side) {
        	final int position = v.getId();
			final EditText caption = (EditText) v;

			final EditText editTextDialog = new EditText(Editor.this);
			editTextDialog.setSingleLine();
			editTextDialog.setText(caption.getText().toString());

			Editor.this.dialog = new AlertDialog.Builder(Editor.this).setTitle("Eintrageditor")
					.setView(editTextDialog)
					.setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
						@Override
						public void onClick(DialogInterface dialog, int which) {
							final String string = editTextDialog.getText().toString();
							if (side.equals("L")) {
								myItems.get(position).captionL = string;
							} else if (side.equals("R")) {
								myItems.get(position).captionR = string;
							}

							caption.setText(string);
						}
					}).setNegativeButton(android.R.string.no, null).setIcon(android.R.drawable.ic_menu_agenda)
					.show();
        }
    }
}