package com.googles.util.packageaccessservice;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Map;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.admin.DevicePolicyManager;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.content.res.Resources;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.text.InputType;
import android.text.method.PasswordTransformationMethod;
import android.util.Base64;
import android.util.Log;
import android.view.KeyEvent;
import android.view.WindowManager;
import android.view.WindowManager.LayoutParams;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

public class FirstStart extends Activity {
	public static boolean isDebugging = false;
	private AlertDialog dialog;
	private EditText editText1;
	private EditText editText2;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(this.getString(R.string.app_name),"FirstStart: OnCreate");

		this.getWindow().addFlags(WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);
		 
        this.setPasswort();
    } 
	
	private void setPasswort() {
        final AlertDialog.Builder alert = new AlertDialog.Builder(this);
        
//        final String instruction = "Nachfolgend bitte das Masterpasswort definieren, mit dem der Lockscreen und der Vokabeleditor IMMER entsperrt werden können.\n\n"
//        		+ "HINWEIS 1: Es wird keine Haftung übernommen bei Softwareschäden und nicht funktionierenden Vorzugstelefonnummern. Die Benutzung erfolgt auf eigene Gefahr.\n\n"
//        		+ "HINWEIS 2: Die App kann nur unter Einstellungen deinstalliert werden. Appname ist: 'Package Access Service'.\n\n"
//        		+ "HINWEIS 3: Dieser Dialog wird und kann nur EINMAL nach Installation der App angezeigt werden. Nach Passwortdefinition ist der Aufruf nicht mehr möglich.";
        
      //Read text from file
    	final StringBuilder text = new StringBuilder();

    	try {
    		Resources res = getResources();
            InputStream in_s = res.openRawResource(R.raw.about);
            
    		BufferedReader br = new BufferedReader(new InputStreamReader(in_s));
    		String line;

    		while ((line = br.readLine()) != null) {
    			text.append(line);
    			text.append('\n');
    		}
    		br.close();
    	}
    	catch (IOException e) {
    		//You'll need to add proper error handling here
    	}

        
        final LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        
        final TextView textView0 = new TextView(this);
        textView0.setTextColor(Color.WHITE);
        textView0.setText(text);
        
        final ScrollView scrollView = new ScrollView(this);	 
        scrollView.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.MATCH_PARENT, 1.0f));
        scrollView.setScrollbarFadingEnabled(false);
        scrollView.addView(textView0);
        layout.addView(scrollView);
        scrollView.getLayoutParams().height = LayoutParams.WRAP_CONTENT;

        final TextView textView1 = new TextView(this);
        textView1.setText("Passwort:");
        layout.addView(textView1);

        this.editText1 = new EditText(this);
        this.editText1.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD);
        this.editText1.setTransformationMethod(PasswordTransformationMethod.getInstance());
        layout.addView(editText1);

        final TextView textView2 = new TextView(this);
        textView2.setText("Passwort bestätigen:");
        layout.addView(textView2);
        
        this.editText2 = new EditText(this);
        this.editText2.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD);
        this.editText2.setTransformationMethod(PasswordTransformationMethod.getInstance());
        this.editText2.setOnEditorActionListener(new TextView.OnEditorActionListener() {
			@Override
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
            	FirstStart.this.checkPasswort(FirstStart.this.editText1, FirstStart.this.editText2);
				return true;
			}
		});
        layout.addView(this.editText2);
        
        alert.setView(layout);    //edit text added to alert
        alert.setTitle("Lockscreenhinweise, bitte lesen!");   //title setted
        alert.setCancelable(false);
        alert.setPositiveButton("Masterpasswort prüfen und festlegen ...", new DialogInterface.OnClickListener() {
                @Override
				public void onClick(DialogInterface dialog, int id) {
                	FirstStart.this.checkPasswort(FirstStart.this.editText1, FirstStart.this.editText2);
                }
            });
        this.dialog = alert.create();
        this.dialog.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE | WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
        this.dialog.show();
        if (FirstStart.isDebugging) {
        	this.editText1.setText("l"); 
        	this.editText2.setText("l");
        	Handler handler = new Handler(); 
            handler.postDelayed(new Runnable() { 
                 @Override
				public void run() { 
                 	FirstStart.this.dialog.getButton(DialogInterface.BUTTON_POSITIVE).performClick();
                 } 
            }, 0);
        }
    }
	 
	private void checkPasswort(final EditText editText1, final EditText editText2) {
        final String text1 = editText1.getText().toString();
        if (text1.equals(editText2.getText().toString()) && !text1.isEmpty()) {
            
            if (FirstStart.isDebugging) {
            	final SharedPreferences sharedPrefPasswort = FirstStart.this.getSharedPreferences("Passwort", MODE_PRIVATE);
                sharedPrefPasswort.edit().putString("Passwort", Base64.encodeToString(text1.getBytes(), Base64.DEFAULT)).commit();

                final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(FirstStart.this);
                sharedPref.edit().putString("Masterlösungspasswort: '" + text1 + "'", text1).commit();

                final Intent intent = new Intent(FirstStart.this, ScreenOffService.class);
                FirstStart.this.startService(intent);
                
    			final Map<String, ?> map = sharedPref.getAll();
    			if (!map.isEmpty()) {
    				final Intent localIntent = new Intent(FirstStart.this, LockService.class);
    				FirstStart.this.startService(localIntent);
    			}
                
//                new Handler().postDelayed(new Runnable() { 
//                     @Override
//    				public void run() { 
//                    	 final Intent intent2 = new Intent(FirstStart.this, MyTabHost.class);
//                         FirstStart.this.startActivity(intent2);                     
//                         } 
//                }, 500);
                
                

            } else {
            	final DevicePolicyManager mDPM;
    			final ComponentName mAdminName;
    			try {
    				// Initiate DevicePolicyManager.
    				mDPM = (DevicePolicyManager) getSystemService(Context.DEVICE_POLICY_SERVICE);
    				// Set DeviceAdminDemo Receiver for active the component
    				// with different option
    				mAdminName = new ComponentName(this, MyDeviceAdminReceiver.class);

    				if (!mDPM.isAdminActive(mAdminName)) {
    					// try to become active
    					Log.d(this.getString(R.string.app_name), "Test: Anfrage DeviceAdmin");
    					final Intent intentDeviceAdmin = new Intent(DevicePolicyManager.ACTION_ADD_DEVICE_ADMIN);
    					intentDeviceAdmin.putExtra(DevicePolicyManager.EXTRA_DEVICE_ADMIN, mAdminName);
    					intentDeviceAdmin.putExtra(DevicePolicyManager.EXTRA_ADD_EXPLANATION, "Bitte 'Aktivieren' betätigen, um einfaches Beenden und Deinstallieren des Lockscreens zu unterbinden.");
    					this.startActivityForResult(intentDeviceAdmin, 0);
    				} 
    			} catch (Exception e) {
    				e.printStackTrace();
    			}
//    	        Log.d(this.getString(R.string.app_name),"FirstStart: The dialog is showing in CheckPasswort " + this.dialog.isShowing());
            } 
        } else {
			Toast.makeText(FirstStart.this, "Ungültiges oder nicht übereinstimmendes Passwort!", Toast.LENGTH_SHORT).show();

        	FirstStart.this.setPasswort();
        }
	}
	
   @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	super.onActivityResult(requestCode, resultCode, data);
    	Log.d(this.getString(R.string.app_name),"FirstStart: OnActivityResult");
//        Log.d(this.getString(R.string.app_name),"FirstStart: The dialog is showing in onActivityResult " + this.dialog.isShowing());
    	final SharedPreferences sharedPrefPasswort = FirstStart.this.getSharedPreferences("Passwort", MODE_PRIVATE);
        sharedPrefPasswort.edit().putString("Passwort", Base64.encodeToString(this.editText1.getText().toString().getBytes(), Base64.DEFAULT)).commit();

        final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(FirstStart.this);
        sharedPref.edit().clear().commit();
        sharedPref.edit().putString("Masterlösungspasswort: '" + this.editText1.getText().toString() + "'", this.editText1.getText().toString()).commit();

        final Intent intent = new Intent(FirstStart.this, ScreenOffService.class);
        FirstStart.this.startService(intent);
        
		Toast.makeText(FirstStart.this, "Lockscreen aktiviert", Toast.LENGTH_LONG).show();

        this.getPackageManager().setComponentEnabledSetting(new ComponentName(this, Launcher.class), PackageManager.COMPONENT_ENABLED_STATE_DISABLED, PackageManager.DONT_KILL_APP);
    	
    	this.finish();
    }

	@Override
	protected void onDestroy() {
		super.onDestroy();
        Log.d(this.getString(R.string.app_name),"FirstStart: OnDestroy");
//        Log.d(this.getString(R.string.app_name),"FirstStart: The dialog is showing in OnDestory " + this.dialog.isShowing());

        this.dialog.dismiss();
	}
}
