package com.googles.util.packageaccessservice;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.graphics.Paint;
import android.hardware.Camera;
import android.net.Uri;
import android.os.Binder;
import android.os.Environment;
import android.os.Handler;
import android.os.IBinder;
import android.os.SystemClock;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;
import android.util.Base64;
import android.util.Log;
import android.view.Display;
import android.view.GestureDetector;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.WindowManager;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.LinearInterpolator;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import android.view.inputmethod.EditorInfo;
import android.widget.AnalogClock;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RatingBar;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.widget.Toast;
import android.widget.ToggleButton;

@SuppressWarnings("deprecation")
public class LockService extends Service {

	private WindowManager windowManager;
	private View view;

	// Statistik
	private int finishedTasks = 0;

	private SharedPreferences prefStatistik;
	private ProgressBar progressBar;
	private TextView textViewAnzahlAufrufe;
	private TextView textViewAnzahlAufgabe;
	private RatingBar ratingBar;

	// Abfrage
	private String result;
	private String aufgabe;
	private Button buttonCheck;
	private EditText editTextErgebnis;
	private Map<String, String> vocabelMap;
	private int tasksToSolve = 5;

	// Sonstiges
	private CheckBox checkBoxMehrAufgaben;
	private AnimationHandling animationHandling;
	private GestureDetector gestureDetector;

	// Hilfefunktion
	private int gapGivenLetters = 8;
	private long startTime;
	private boolean isHelping = false;
	private Handler handler = new Handler();

	private LinearLayout linearLayoutHelp;
	private Button buttonHilfe;
	private EditText editTextTipp;
	private TextView textViewTipp1;
	private TextView textViewTipp2;
	private EditText editTextAuf1;
	private EditText editTextAuf2;
	private EditText editTextAuf3;
	private EditText editTextRes1;
	private EditText editTextRes2;
	private EditText editTextRes3;
	private TextView editTextEq2;
	private TextView editTextEq3;
	private TextView textViewEdit;

	// Telefonvariablen
	private PhoneHandling phoneHandling;
	private Boolean hasIncomingCall;
	public int callState;

	// Camera
	private CameraHandling cameraHandling;
	private Camera camera;
	private SurfaceView surfaceView;
	private SurfaceHolder surfaceHolder;
	private Camera.PictureCallback rawCallback;
	private Camera.ShutterCallback shutterCallback;
	private Camera.PictureCallback jpegCallback;
	private final String tag = "VideoServer";
	private ImageButton imageButtonCapture;

	@SuppressWarnings("unchecked")
	@Override
	public void onCreate() {
		super.onCreate();
		Log.d(this.getString(R.string.app_name), "LockService: OnCreated");

		// View
		this.setTheme(R.style.AppTheme);

		final WindowManager.LayoutParams params = new WindowManager.LayoutParams(WindowManager.LayoutParams.TYPE_PHONE);
		params.screenOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT;
//		params.flags = WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN;
		this.view = View.inflate(this, R.layout.lock_screen, null);
		this.windowManager = ((WindowManager) this.getSystemService(WINDOW_SERVICE));
		this.windowManager.addView(this.view, params);

		// Statistik
		this.prefStatistik = this.getSharedPreferences("Statistik", Context.MODE_PRIVATE);
		
		final int lastDay = this.prefStatistik.getInt("LETZTER_TAG", -1);
		final Calendar calendar = Calendar.getInstance();
		final int day = calendar.get(Calendar.DAY_OF_MONTH); 
		Log.d(this.getString(R.string.app_name), "LockService: Lastday: " + lastDay + " Heute: " + day);
		if (lastDay != day) {
			this.prefStatistik.edit().putInt("LETZTER_TAG", day).commit();
			this.prefStatistik.edit().putInt("ANZAHL", 0).commit();
			this.prefStatistik.edit().putBoolean("JOKER", true).commit();
		}
		
		int nLockServices = this.prefStatistik.getInt("ANZAHL", 0) + 1;
		this.prefStatistik.edit().putInt("ANZAHL", nLockServices).commit();
		this.textViewAnzahlAufrufe = (TextView) view.findViewById(R.id.textViewAnzahlAufrufe);
		this.textViewAnzahlAufrufe.setText(String.valueOf(nLockServices));

		this.ratingBar = (RatingBar) view.findViewById(R.id.ratingBar);
		this.setRating();
		this.finishedTasks = (int) this.prefStatistik.getFloat("MITTELWERT", 2.99f);

		this.gestureDetector = new GestureDetector(new GestureDetector.SimpleOnGestureListener() {
			
			@Override
	        public boolean onDown(MotionEvent e) {
	            return true;
	        } 
			
			@Override
			public boolean onDoubleTap(MotionEvent e) {
				Log.d("Widmungsbutton","Wurde lange gedrückt");
				final AlertDialog.Builder builder = new AlertDialog.Builder(LockService.this)
				.setTitle("Programmwidmung")
				.setMessage("Für Robin und Ken\n\n-Moppel")
				.setIcon(android.R.drawable.star_big_on);
				final AlertDialog dialog = builder.create();
				dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
				dialog.show();
				return true;
			}
		});
		this.ratingBar.setOnTouchListener(new OnTouchListener() {
		    @SuppressLint("ClickableViewAccessibility")
			@Override
		    public boolean onTouch(View v, MotionEvent event) {
		        return LockService.this.gestureDetector.onTouchEvent(event);
		    }
		});
		this.progressBar = (ProgressBar) view.findViewById(R.id.progressBar);
		this.progressBar.setMax(this.tasksToSolve);
		this.progressBar.setProgress(this.finishedTasks);

		this.progressBar.setMax(this.tasksToSolve);
		
		// Hilfefunktion
		this.textViewEdit = (TextView) view.findViewById(R.id.textViewEdit);
		this.textViewEdit.setPaintFlags(this.textViewEdit.getPaintFlags() | Paint.UNDERLINE_TEXT_FLAG);
		this.textViewEdit.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				LockService.this.textViewEdit.setText("Editor startet nach Entsperren ...");
				LockService.this.textViewEdit.setTextColor(Color.RED);

				final Intent localIntent = new Intent(LockService.this, MyTabHost.class);
				localIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				LockService.this.startActivity(localIntent);
			}
		});
		this.editTextAuf1 = (EditText) view.findViewById(R.id.editTextAuf1);
		this.editTextAuf2 = (EditText) view.findViewById(R.id.editTextAuf2);
		this.editTextAuf3 = (EditText) view.findViewById(R.id.editTextAuf3);
		this.editTextRes1 = (EditText) view.findViewById(R.id.editTextRes1);
		this.editTextRes2 = (EditText) view.findViewById(R.id.editTextRes2);
		this.editTextRes3 = (EditText) view.findViewById(R.id.editTextRes3);
		this.editTextEq2 = (TextView) view.findViewById(R.id.textViewEq2);
		this.editTextEq3 = (TextView) view.findViewById(R.id.textViewEq3);
		this.linearLayoutHelp = (LinearLayout) view.findViewById(R.id.linearLayoutViewGroup);
		this.editTextTipp = (EditText) view.findViewById(R.id.editTextTipp);
		this.textViewTipp1 = (TextView) view.findViewById(R.id.textViewTipp1);
		this.textViewTipp2 = (TextView) view.findViewById(R.id.textViewTipp2);
		this.buttonHilfe = (Button) view.findViewById(R.id.buttonHilfe);
		this.buttonHilfe.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				LockService.this.gapGivenLetters /= 2;
				
				if (gapGivenLetters == 4) {
					LockService.this.editTextTipp.setVisibility(View.VISIBLE);
					LockService.this.linearLayoutHelp.setVisibility(View.VISIBLE);
					LockService.this.textViewTipp1.setVisibility(View.VISIBLE);
					LockService.this.textViewTipp2.setVisibility(View.VISIBLE);
				} else if (gapGivenLetters == 2) {
					LockService.this.editTextAuf2.setVisibility(View.VISIBLE);
					LockService.this.editTextRes2.setVisibility(View.VISIBLE);
					LockService.this.editTextEq2.setVisibility(View.VISIBLE);
				} else if (gapGivenLetters == 1) {
					LockService.this.editTextAuf3.setVisibility(View.VISIBLE);
					LockService.this.editTextRes3.setVisibility(View.VISIBLE);
					LockService.this.editTextEq3.setVisibility(View.VISIBLE);
					LockService.this.buttonHilfe.setEnabled(false);
				} 

				LockService.this.buttonHilfe.setEnabled(false);
				LockService.this.editTextTipp.setText(LockService.this.applyUnderline());
				LockService.this.startTime = System.currentTimeMillis();
				LockService.this.isHelping = true;
				if (gapGivenLetters != 1) {
					LockService.this.handler.post(new Runnable() {
						@Override
						public void run() {
							final long millis = 3000 - (System.currentTimeMillis() - LockService.this.startTime);
							final int seconds = (int) (millis / 1000);
							
							if (seconds == 0) {
								LockService.this.buttonHilfe.setEnabled(true);
								LockService.this.buttonHilfe.setText("Hilfe!");
							} else {
								LockService.this.buttonHilfe.setText(String.valueOf(seconds));
								LockService.this.handler.postDelayed(this, 1000);
							}
						}
					});
				}
			}
		});

		final AnalogClock clock = (AnalogClock) this.view.findViewById(R.id.analogClock1);
		clock.setOnTouchListener(new OnTouchListener() {

			@SuppressLint("ClickableViewAccessibility")
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				if (LockService.this.prefStatistik.getBoolean("JOKER", false)) {
					Toast.makeText(LockService.this, "Joker benutzt", Toast.LENGTH_LONG).show();;
					LockService.this.prefStatistik.edit().putBoolean("JOKER", false).commit();
					LockService.this.stopSelf();
				}
				return false;
			}
		});

		this.checkBoxMehrAufgaben = (CheckBox) view.findViewById(R.id.checkBoxMehrAufgaben);

		this.buttonCheck = (Button) view.findViewById(R.id.buttonCheck);
//		this.buttonCheck.bringToFront();
//		((View) this.buttonCheck.getParent()).requestLayout();
//		((View) this.buttonCheck.getParent()).invalidate();
		this.buttonCheck.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				LockService.this.inputInserted();
			}
		});
		this.editTextErgebnis = (EditText) view.findViewById(R.id.editTextErgebnis);
		this.editTextErgebnis.postDelayed(new Runnable() {
			@SuppressLint("Recycle")
			@Override
			public void run() {
				LockService.this.editTextErgebnis.dispatchTouchEvent(MotionEvent.obtain(SystemClock.uptimeMillis(), SystemClock.uptimeMillis(), MotionEvent.ACTION_DOWN , 0, 0, 0));
				LockService.this.editTextErgebnis.dispatchTouchEvent(MotionEvent.obtain(SystemClock.uptimeMillis(), SystemClock.uptimeMillis(), MotionEvent.ACTION_UP , 0, 0, 0)); 
			}
		}, 500);

		this.editTextErgebnis.setOnEditorActionListener(new OnEditorActionListener() {
			@Override
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				if ((actionId == EditorInfo.IME_ACTION_DONE) || (actionId == EditorInfo.IME_ACTION_NEXT)) {
					LockService.this.inputInserted();
				}
				return true;
			}
		});

		final SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
		this.vocabelMap = (Map<String, String>) sharedPref.getAll();
		for (Entry<String, ?> entry : vocabelMap.entrySet()) {
			Log.d(this.getString(R.string.app_name), "Keys/Value: " + entry.getKey() + "/" + entry.getValue());
		}
		
		this.textViewAnzahlAufgabe = (TextView) view.findViewById(R.id.textViewAufgabe);
		this.generateRandomTask();
		
		// Animation
		this.animationHandling = new AnimationHandling();
		this.animationHandling.setup();
		
		// Telefonie
		this.phoneHandling = new PhoneHandling();
		this.phoneHandling.setup();

		// Camera
		this.cameraHandling = new CameraHandling();
		cameraHandling.setup();
	}

	private void calcRating(float letztesErgebnis) {
		final float mittelWert = this.prefStatistik.getFloat("MITTELWERT", 2.99f);
		final float newQuote = (1.0f*letztesErgebnis + 19.0f*mittelWert)/20.0f;
		this.prefStatistik.edit().putFloat("MITTELWERT", newQuote).commit();
		this.setRating();
	}

	private void setRating() {
		final float quote = this.prefStatistik.getFloat("MITTELWERT", 2.99f);
		this.ratingBar.setRating(quote);
	}

	private String applyUnderline() {
		final StringBuilder sb = new StringBuilder(this.result.length());
		sb.append(this.result.charAt(0));
		for (int i = 1; i < this.result.length(); i++) {
			if ((i % this.gapGivenLetters) == 0) {
				sb.append(this.result.charAt(i));
			} else {
				sb.append('_');
			}
		}
		return sb.toString();
	}

	private void generateRandomTask() {
		final Random random = new Random();
		final List<String> keys = new ArrayList<String>(this.vocabelMap.keySet());
		final String randomKey = keys.get(random.nextInt(keys.size()));
		final String value = this.vocabelMap.get(randomKey);
		this.textViewAnzahlAufgabe.setText(randomKey);
		this.aufgabe = randomKey;
		this.result = value;
	}

	private void hideHelp() {
		this.editTextTipp.setVisibility(View.GONE);
		this.linearLayoutHelp.setVisibility(View.GONE);
		this.textViewTipp1.setVisibility(View.GONE);
		this.textViewTipp2.setVisibility(View.GONE);
	
		this.editTextAuf1.getText().clear();
		this.editTextAuf2.getText().clear();
		this.editTextAuf3.getText().clear();
		this.editTextRes1.getText().clear();
		this.editTextRes2.getText().clear();
		this.editTextRes3.getText().clear();
	
		this.editTextAuf2.setVisibility(View.GONE);
		this.editTextAuf3.setVisibility(View.GONE);
		this.editTextRes2.setVisibility(View.GONE);
		this.editTextRes3.setVisibility(View.GONE);
		this.editTextEq2.setVisibility(View.GONE);
		this.editTextEq3.setVisibility(View.GONE);
	
		this.buttonHilfe.setEnabled(true);
		this.isHelping = false;
		this.gapGivenLetters = 8;
	}

	private void inputInserted() {
		final String input = this.editTextErgebnis.getText().toString();
		if (!input.isEmpty()) {

			final int result = this.isResultOkay(input);
		
			if (result == 1) {
				this.animationHandling.startRightResultAnim();
				
				this.editTextErgebnis.getText().clear();
				
				if (this.checkBoxMehrAufgaben.isChecked()) {
					this.calcRating(5.0f);
				} else {
					if (this.gapGivenLetters == 8) {
						this.calcRating(5.0f);
					} else if (this.gapGivenLetters == 2) {
						this.calcRating(0.0f);
					};
				}

				this.generateRandomTask();
				this.hideHelp();
	
				if (!this.checkBoxMehrAufgaben.isChecked()) {
					this.finishedTasks++;
					this.progressBar.setProgress(this.finishedTasks);
	
					if (finishedTasks == LockService.this.tasksToSolve) {
						this.stopSelf();
					}
				}
			} else if (result == -1) {
				this.animationHandling.startWrongResultAnim();
				
				if (!this.checkBoxMehrAufgaben.isChecked()) {
					this.calcRating(0.0f);
				}
			}
		} else {
			this.animationHandling.startWrongResultAnim();
		}
	}
	
	private int isResultOkay(final String pInput) {
		final SharedPreferences sharedPrefPasswort = LockService.this.getSharedPreferences("Passwort", MODE_PRIVATE);
		final String passwortEnc = sharedPrefPasswort.getString("Passwort", "");
		final String passwortDec = new String(Base64.decode(passwortEnc, Base64.DEFAULT));

		if (pInput.equals(passwortDec)) {
			this.stopSelf();
			return 0;
		}

		if (!pInput.equals(this.result)) {
			return -1;
		}

		if (this.isHelping) {
			if (gapGivenLetters == 1) {
				if (this.editTextAuf1.getText().toString().equals(this.aufgabe)
						&& this.editTextAuf2.getText().toString().equals(this.aufgabe)
						&& this.editTextAuf3.getText().toString().equals(this.aufgabe)
						&& this.editTextRes1.getText().toString().equals(this.result)
						&& this.editTextRes2.getText().toString().equals(this.result)
						&& this.editTextRes3.getText().toString().equals(this.result)) {
					return 1;
				} else {
					return -1;
				}
			} else if (gapGivenLetters == 2) {
				if (this.editTextAuf1.getText().toString().equals(this.aufgabe)
						&& this.editTextAuf2.getText().toString().equals(this.aufgabe)
						&& this.editTextRes1.getText().toString().equals(this.result)
						&& this.editTextRes2.getText().toString().equals(this.result)) {
					return 1;
				} else {
					return -1;
				}
			} else if (gapGivenLetters == 4) {
				if (this.editTextAuf1.getText().toString().equals(this.aufgabe)
						&& this.editTextRes1.getText().toString().equals(this.result)) {
					return 1;
				} else {
					return -1;
				}
			}
		} else {
			return 1;
		}

		Log.d(this.getString(R.string.app_name), "LockService: Ich soll hier nicht sein ...");
		return 1;
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		Log.d(this.getString(R.string.app_name), "LockService: onStartCommand");
	
		return super.onStartCommand(intent, flags, startId);
	}

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		Log.d(this.getString(R.string.app_name), "Lockservice: OnDestroy");
		
		if (this.view != null)
			windowManager.removeView(view);
		if (this.camera != null) {
			this.cameraHandling.stop_camera();
		}
	}
	
	private class AnimationHandling {
		private RatingBar clonedRatingBar;
		private ImageView imageViewStar;
		
		private void setup() {
			this.clonedRatingBar = (RatingBar) LockService.this.view.findViewById(R.id.ratingBarClone);
			this.imageViewStar   = (ImageView) LockService.this.view.findViewById(R.id.imageViewStar);
		}
		
		
		private void startWrongResultAnim() {
			final Animation animTrans = new TranslateAnimation(-10.0f, 10.0f, 0, 0);
			animTrans.setDuration(50); 
			animTrans.setStartOffset(0);
			animTrans.setRepeatMode(Animation.REVERSE);
			animTrans.setRepeatCount(5);
			LockService.this.editTextErgebnis.startAnimation(animTrans);
		}
		
		private void startRightResultAnim() {
			final AnimationSet animSetRatingBar = new AnimationSet(true);
			animSetRatingBar.setStartOffset(800);
			final Animation animScale = new ScaleAnimation(1.0f, 2.0f, 1.0f, 2.0f, Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
			animScale.setDuration(1000); 
			animSetRatingBar.addAnimation(animScale);
			final Animation animFade = new AlphaAnimation(1.0f, 0.0f);
			animFade.setDuration(1000); 
			animSetRatingBar.addAnimation(animFade);
			clonedRatingBar.startAnimation(animSetRatingBar);
			
			final AnimationSet animSetStar = new AnimationSet(false);
			animSetStar.setInterpolator(new LinearInterpolator());
//			animSetStar.setAnimationListener(new AnimationListener() {
//				
//				@Override
//				public void onAnimationStart(Animation animation) {
//				}
//				
//				@Override
//				public void onAnimationRepeat(Animation animation) {
//				}
//				
//				@Override
//				public void onAnimationEnd(Animation animation) {
//					Log.d("Animation", "Ended");
//					AnimationHandling.this.imageViewStar.setVisibility(View.INVISIBLE);
//				}
//			});
			final Animation animTranIn = new TranslateAnimation(Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF,  0.0f, 
														        Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, -4.0f);
			animTranIn.setDuration(1000); 
			animSetStar.addAnimation(animTranIn);
			final Animation animFadeIn = new AlphaAnimation(0.0f, 1.0f);
			animFadeIn.setDuration(200); 
			animSetStar.addAnimation(animFadeIn);
			final Animation animFadeOut = new AlphaAnimation(1.0f, 0.0f);
			animFadeOut.setDuration(800); 
			animFadeOut.setStartOffset(200);
			animSetStar.addAnimation(animFadeOut);
			final Animation animRotate = new ScaleAnimation(1.0f, 0.0f, 1.0f, 1.0f, Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
			animRotate.setDuration(500); 
			animRotate.setRepeatCount(2);
			animRotate.setInterpolator(new CosInterpolator());
			animSetStar.addAnimation(animRotate);
			this.imageViewStar.startAnimation(animSetStar);
		}
		
		private class CosInterpolator implements android.view.animation.Interpolator {

			@Override
			public float getInterpolation(float input) {
				return (float) (0.5*Math.cos(Math.PI*2*input) + 0.5);
			}
		}
	}

	private class PhoneHandling {

		public void setup() {
			final Button buttonDenyCall = (Button) view.findViewById(R.id.buttonDenyCall);
			buttonDenyCall.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					Log.d(LockService.this.getString(R.string.app_name), "LockService: DenyCall: Callstate " + callState);

					PhoneHandling.this.handleCall(false);
				}
			});
			
			final SharedPreferences sharedPrefTel = LockService.this.getSharedPreferences("Nummer", MODE_PRIVATE);

			final Spinner spinnerCallList = (Spinner) view.findViewById(R.id.spinnerCallListe);
			final List<String> list = new ArrayList<String>();
			list.add(sharedPrefTel.getString("nr1Name", ""));
			list.add(sharedPrefTel.getString("nr2Name", ""));
			list.add(sharedPrefTel.getString("nr3Name", ""));
			list.add(sharedPrefTel.getString("nr4Name", ""));
			list.add(sharedPrefTel.getString("nr5Name", ""));
			list.add(sharedPrefTel.getString("nr6Name", ""));
			list.removeAll(Arrays.asList(""));
			if (list.isEmpty()) {
				list.add("Kein Eintrag");
			}
			final ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(LockService.this, android.R.layout.simple_spinner_item, list);
			dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			spinnerCallList.setAdapter(dataAdapter);

			final Button buttonAcceptCall = (Button) view.findViewById(R.id.buttonAcceptCall);
			buttonAcceptCall.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					Log.d(LockService.this.getString(R.string.app_name), "LockService: AcceptCall: Callstate " + callState);
					
					final int callState = ((TelephonyManager) getSystemService(TELEPHONY_SERVICE)).getCallState();
					if (callState == TelephonyManager.CALL_STATE_RINGING) {
						PhoneHandling.this.handleCall(true);
					} else if (callState == TelephonyManager.CALL_STATE_IDLE) {
						if (spinnerCallList.getCount() > 0) {
							final int selectedPos = spinnerCallList.getSelectedItemPosition();
							
							Intent intent = new Intent(Intent.ACTION_CALL);
							intent.setData(Uri.parse("tel:" + sharedPrefTel.getString("nr" + (selectedPos+1) + "Nr", "")));
							intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
							LockService.this.startActivity(intent);
						}
					}
				}
			});
		}

		private void handleCall(final boolean hasToAcceptCall) {
			try {
				// String serviceManagerName = "android.os.IServiceManager";
				String serviceManagerName = "android.os.ServiceManager";
				String serviceManagerNativeName = "android.os.ServiceManagerNative";
				String telephonyName = "com.android.internal.telephony.ITelephony";
		
				Class<?> telephonyClass;
				Class<?> telephonyStubClass;
				Class<?> serviceManagerClass;
				Class<?> serviceManagerNativeClass;
				Method telephonyEndCall;
				Method telephonyAnswerCall;
				// Method getService;
				Object telephonyObject;
				Object serviceManagerObject;
		
				telephonyClass = Class.forName(telephonyName);
				telephonyStubClass = telephonyClass.getClasses()[0];
				serviceManagerClass = Class.forName(serviceManagerName);
				serviceManagerNativeClass = Class.forName(serviceManagerNativeName);
		
				Method getService = // getDefaults[29];
						serviceManagerClass.getMethod("getService", String.class);
		
				Method tempInterfaceMethod = serviceManagerNativeClass.getMethod("asInterface", IBinder.class);
		
				Binder tmpBinder = new Binder();
				tmpBinder.attachInterface(null, "fake");
		
				serviceManagerObject = tempInterfaceMethod.invoke(null, tmpBinder);
				IBinder retbinder = (IBinder) getService.invoke(serviceManagerObject, "phone");
				Method serviceMethod = telephonyStubClass.getMethod("asInterface", IBinder.class);
		
				telephonyObject = serviceMethod.invoke(null, retbinder);
				// telephonyCall = telephonyClass.getMethod("call", String.class);
		
				Log.d(LockService.this.getString(R.string.app_name), "LockService: Has incoming call? " + LockService.this.hasIncomingCall);
		
				if (hasToAcceptCall) {
					telephonyAnswerCall = telephonyClass.getMethod("answerRingingCall");
					telephonyAnswerCall.setAccessible(true);
					telephonyAnswerCall.invoke(telephonyObject);
				} else {
					telephonyEndCall = telephonyClass.getMethod("endCall");
					telephonyEndCall.invoke(telephonyObject);
				}
			} catch (Exception e) {
				e.printStackTrace();
				Log.e(LockService.this.getString(R.string.app_name), "LockService: FATAL ERROR: could not connect to telephony subsystem");
				Log.e(LockService.this.getString(R.string.app_name), "LockService: Exception object: " + e);
			}
		}
	}

	private class CameraHandling {

		public void setup() {

			LockService.this.imageButtonCapture = (ImageButton) view.findViewById(R.id.imageButtonFoto);
			LockService.this.imageButtonCapture.setEnabled(false);
			LockService.this.imageButtonCapture.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					captureImage();
				}
			});

			surfaceView = (SurfaceView) view.findViewById(R.id.surfaceView);
//			surfaceView.setVisibility(View.INVISIBLE);
			surfaceHolder = surfaceView.getHolder();
//			surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_CPUSH_BUFFERS);
			rawCallback = new Camera.PictureCallback() {
				@Override
				public void onPictureTaken(byte[] data, Camera camera) {
					Log.d(LockService.this.getString(R.string.app_name), "LockService: onPictureTaken - raw");
				}
			};
			
			final ToggleButton buttonNummerCamera = (ToggleButton) view.findViewById(R.id.toggleButtonCamera);
			buttonNummerCamera.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
				@Override
				public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
					if (isChecked) {
						surfaceView.setVisibility(View.VISIBLE);
						Toast.makeText(LockService.this, "Kamera startet,\nbitte warten ...", Toast.LENGTH_LONG).show();;
						start_camera();
						buttonNummerCamera.setEnabled(false);
						new Handler().postDelayed(new Runnable() {
							
							@Override
							public void run() {
								buttonNummerCamera.setEnabled(true);
							}
						}, 3000);
						LockService.this.imageButtonCapture.setEnabled(true);
					} else {
						Toast.makeText(LockService.this, "Kamera stoppt,\nbitte warten ...", Toast.LENGTH_LONG).show();
						buttonNummerCamera.setEnabled(false);
						new Handler().postDelayed(new Runnable() {
							
							@Override
							public void run() {
								buttonNummerCamera.setEnabled(true);
							}
						}, 3000);
						LockService.this.imageButtonCapture.setEnabled(false);
						stop_camera();
						surfaceView.setVisibility(View.INVISIBLE);
					}
				}
			});

			/** Handles data for jpeg picture */
			shutterCallback = new Camera.ShutterCallback() {
				@Override
				public void onShutter() {
					Log.i("Log", "onShutter'd");
				}
			};
			jpegCallback = new Camera.PictureCallback() {
				@Override
				public void onPictureTaken(byte[] data, Camera camera) {
					FileOutputStream outStream = null;
					try {
						outStream = new FileOutputStream(String.format(Environment.getExternalStorageDirectory().getPath() + "/%d.jpg", System.currentTimeMillis()));
						outStream.write(data);
						outStream.close();
						Toast.makeText(LockService.this, "Bild im internen\nSpeicher abgespeichert", Toast.LENGTH_SHORT).show();;
						Log.d(LockService.this.getString(R.string.app_name), "LockService: OnPictureTaken - wrote bytes: " + data.length);
					} catch (FileNotFoundException e) {
						e.printStackTrace();
					} catch (IOException e) {
						e.printStackTrace();
					} finally {
					}
					camera.startPreview();
				}
			};
		}

		private void captureImage() {
			camera.takePicture(shutterCallback, rawCallback, jpegCallback);
		}

		private void start_camera() {
			try {
				camera = Camera.open();
			} catch (RuntimeException e) {
				Log.e(tag, "init_camera: " + e);
				return;
			}
			Camera.Parameters param;
			param = camera.getParameters();
			// modify parameter
			// param.setRotation(270);
			// param.setPreviewFrameRate(20);
			// param.setPreviewSize(176, 144);
			List<Camera.Size> sizes = param.getSupportedPictureSizes();
			Camera.Size size = sizes.get(0);
			for (int i = 0; i < sizes.size(); i++) {
				if (sizes.get(i).width > size.width)
					size = sizes.get(i);
//				Log.d(LockService.this.getString(R.string.app_name), "Lsize.width" + size.width + "size.height" + size.height);

			}
			// param.setPictureSize(size.width, size.height);

			// List<Camera.Size> previewSizes =
			// param.getSupportedPreviewSizes();
			//
			//
			// // for (Camera.Size eachSize : previewSizes) {
			// // Log.d("huhu", "h" + eachSize.height + " w " + eachSize.width);
			// //}
			WindowManager wm = (WindowManager) LockService.this.getSystemService(Context.WINDOW_SERVICE);
			Display display = wm.getDefaultDisplay();
			//
			// int iBest = 1;
			// Camera.Size previewSize = null;
			// for (int i = 1; i <= previewSizes.size(); i++) {
			// previewSize = previewSizes.get(previewSizes.size()-i);
			// if ((previewSize.width < display.getWidth()) &&
			// (previewSize.width > previewSizes.get(previewSizes.size() -
			// iBest).width)) {
			// iBest = i;
			// }
			// }
			// previewSize = previewSizes.get(previewSizes.size()-iBest);
			//
			// ; //480h x 720w
			// Log.d("huhu", "display.getWidth()" + display.getWidth());
			//
			// Log.d("huhu", "h" + previewSize.height + " w " +
			// previewSize.width);

			// param.setPreviewSize(previewSize.width, previewSize.height);
			surfaceView.getLayoutParams().width = display.getWidth() / 2;// previewSize.height
																			// ;//(int)
																			// (surfaceView.getLayoutParams().width
																			// *
																			// 480.0f
																			// /
																			// 720.0f);
			surfaceView.getLayoutParams().height = surfaceView.getLayoutParams().width * size.width / size.height; // previewSize.width
//			surfaceView.setLayoutParams(surfaceView.getLayoutParams());																										// ;//(int)
			param.setFlashMode(Camera.Parameters.FLASH_MODE_AUTO);
			param.setFocusMode(Camera.Parameters.FOCUS_MODE_AUTO);
			camera.setParameters(param);
			camera.setDisplayOrientation(90);
			new Handler().post(new Runnable() {
				@Override
				public void run() {
					try {
						camera.setPreviewDisplay(surfaceHolder);
						camera.startPreview();
						// camera.takePicture(shutter, raw, jpeg)
					} catch (Exception e) {
						Log.e(tag, "init_camera: " + e);
						return;
					}
					
				}
			});
		}

		private void stop_camera() {
//			 camera.setPreviewCallback(null);
			new Handler().postDelayed(new Runnable() {
				@Override
				public void run() {
					camera.stopPreview();
					camera.release();
					camera = null;
//				}
			}}, 100);
		}
	}
	

	
}
