package com.googles.util.packageaccessservice;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Environment;
import android.text.InputType;
import android.text.method.PasswordTransformationMethod;
import android.util.Base64;
import android.view.KeyEvent;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class UtilTools {
	public static void loadEmergencyNumbers(final Context pContext) {
		// NOTFALLNUMMERN
		final SharedPreferences sharedPrefTel = pContext.getSharedPreferences("Nummer", Context.MODE_PRIVATE);
		final File sdcard = Environment.getExternalStorageDirectory();

		final File file = new File(sdcard, "notfallnummern.txt");
		if (file.exists()) {
			sharedPrefTel.edit().clear().commit();

			try {
				BufferedReader br = new BufferedReader(new FileReader(file));
				String line;
				String[] split;

				while ((line = br.readLine()) != null) {
					split = line.split("#");
					if (split.length == 3) {
						sharedPrefTel.edit().putString(split[0] + "Name", split[1]).commit();
						sharedPrefTel.edit().putString(split[0] + "Nr", split[2]).commit();
					}
				}
				br.close();
			} catch (IOException e) {
				System.out.println("Error read Nummern");
			}
		}
	}
	
    public static AlertDialog showLoginPassword(final Activity pContext) {
    	final SharedPreferences sharedPrefPasswort = pContext.getSharedPreferences("Passwort", Context.MODE_PRIVATE);
        final String passwortDec = sharedPrefPasswort.getString("Passwort", "");
        final String passwortEnc = new String(Base64.decode(passwortDec, Base64.DEFAULT));
        
        final AlertDialog.Builder builder = new AlertDialog.Builder(pContext);
        final EditText input = new EditText(pContext);

        builder.setView(input);    //edit text added to alert
        builder.setTitle("Passwort eingeben:");   //title setted
        builder.setCancelable(false);
        builder.setPositiveButton("Prüfen ...",
                new DialogInterface.OnClickListener() {
                    @Override
					public void onClick(DialogInterface dialog, int id) {
                        if (!input.getText().toString().equals(passwortEnc)) {
                            UtilTools.showLoginPassword(pContext);
                        }
                    }
                });
        builder.setNegativeButton("Abbrechen",
                new DialogInterface.OnClickListener() {
                    @Override
					public void onClick(DialogInterface dialog, int id) {
                    	dialog.dismiss();;
                    	pContext.finish();
                    }
                });
        final AlertDialog dialog = builder.create();
//        dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
       
        input.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD);
        input.setTransformationMethod(PasswordTransformationMethod.getInstance());
        input.setOnEditorActionListener(new OnEditorActionListener() {
			@Override
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				if ((actionId == EditorInfo.IME_ACTION_DONE) || (actionId == EditorInfo.IME_ACTION_NEXT)) {
                    if (!input.getText().toString().equals(passwortEnc)) {
                        UtilTools.showLoginPassword(pContext);
                    } 
                	dialog.dismiss();
				}
				return true;
			}
		});
        
        dialog.show();
        return dialog;
    }
}
